=== modified file 'bzrlib/gpg.py'
--- bzrlib/gpg.py	2011-12-19 13:23:58 +0000
+++ bzrlib/gpg.py	2012-02-26 19:21:01 +0000
@@ -190,7 +190,7 @@
             # use the user email address
             key = config.extract_email_address(self._config_stack.get('email'))
         return [self._config_stack.get('gpg_signing_command'), '--clearsign',
-                '-u', key]
+                '-u', key '--no-tty']
 
     def sign(self, content):
         if isinstance(content, unicode):

=== modified file 'bzrlib/tests/test_gpg.py'
--- bzrlib/tests/test_gpg.py	2011-12-21 14:25:26 +0000
+++ bzrlib/tests/test_gpg.py	2012-02-26 19:21:01 +0000
@@ -51,7 +51,7 @@
         self.my_gpg = gpg.GPGStrategy(FakeConfig())
 
     def test_signing_command_line(self):
-        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com'],
+        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com', '--no-tty'],
                          self.my_gpg._command_line())
 
     def test_signing_command_line_from_default(self):
@@ -60,7 +60,7 @@
 email=Amy <amy@example.com>
 gpg_signing_key=default
 gpg_signing_command=false'''))
-        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com'],
+        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com', '--no-tty'],
                          my_gpg._command_line())
 
     def test_signing_command_line_from_email(self):
@@ -68,7 +68,7 @@
         my_gpg = gpg.GPGStrategy(FakeConfig('''
 email=Amy <amy@example.com>
 gpg_signing_command=false'''))
-        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com'],
+        self.assertEqual(['false',  '--clearsign', '-u', 'amy@example.com', '--no-tty'],
                          my_gpg._command_line())
 
     def test_checks_return_code(self):

=== modified file 'doc/en/release-notes/bzr-2.5.txt'
--- doc/en/release-notes/bzr-2.5.txt	2012-02-24 12:15:02 +0000
+++ doc/en/release-notes/bzr-2.5.txt	2012-02-26 19:21:01 +0000
@@ -1072,6 +1072,9 @@
   operations that use it, like merge, can now create trees without a root.
   (Aaron Bentley)
 
+* Fixed problem with getting errors about failing to open /dev/tty when using
+  Bazaar Explorer to sign commits. (Mark Grandi, #847388)
+
 Documentation
 *************
 

